8月11日shell编程脚本及课后作业

shell脚本编程

本章内容

编程基础

脚本基础格式

变量

运算

条件测试

流程控制

函数

数组

高级字符串操作

高级变量

配置用户环境

编程基础

程序:指令+数据
   程序编程风格:
      过程式:以指令为中心,数据服务于指令
      对象式:以数据为中心,指令服务于数据
   shell:提供了编程能力,解释执行  

 计算机:运行二进制指令;
 编程语言:
    低级:汇编
    高级:
          编译:高级语言-->编辑器-->目标代码
                java,c#
          解释:高级语言-->解释器-->机器代码
                shell,perl,python
编程基本处理方式:
      顺序执行
      循环执行
      选择执行
  shell编程:过程式、解释执行
     编程语言的基本结构:
        数据存储:变量、数组
        表达式:a+b
        语句:if
shell脚本基础
      shell脚本是包含一些命令或声明,并符合一定格式的文本文件
      格式要求:首行shebang机制
         #!/bin/bash
         #!/usr/bin/python
         #!/usr/bin/perl
      shell脚本的用途有:
          自动化常用命令
          执行系统管理和故障排除
          创建简单的应用程序
          处理文本或文件
创建shell脚本
       第一步;使用文本编辑器来创建文本文件
          第一行必须包括shell声明序列:#!
              #!/bin/bash
          添加注释
              注释以#开头
       第二步:运行脚本
         给予执行权限,在命令行上指定脚本的绝对或相对路径
         直接运行解释器,将脚本作为解释器程序的参数运行

      shell脚本范例
        #!/bin/bash
        #author:zhoushuang
        #Version:1.0
        #Description:This script displays some information about you# environment
        echo "Greetings. The date and time are $(date)"
        echo "Your working directory is:$(pwd)"
脚本调试
        bash -n /path/to/some_script
           检测脚本中的用法错误
        bash -x /path/to/some_script
           调试执行
    变量:命名的内存空间
       数据存储方式:
           字符:
           数值:整型,浮点型
    变量:变量类型
        作用:
           1、数据存储格式
           2、参与的运算
           3、表示的数据范围
        类型:
           字符
           数值:整型、浮点型
编程程序语言分类
     强类型:定义变量时必须制定类型、参与运算必须符合类型要求;强调未声明变量会产生错误
          如  java,python
     弱类型:无线制定类型,默认均为字符型;参与运算会自动进行隐式类型转换;变量无须事先定义可直接调用
          如:bash 不支持浮点数
     变量命名法则:
        1、不能使程序中的保留字:例如if,for;
        2、只能使用数字、字母及下划线,且不能以数字开头
        3、见名知义
        4、统一命名规则:驼峰命名法
bash中变量的种类
   根据变量的生效范围等标准:
     本地变量:生效范围为当前shell进程;对当前shell之外的其他shell进程,包括当前shell的子进程均无效
     环境变量:生效范围为当前shell进程及其子进程
     局部变量:生效范围为当前shell进程中某代码片段(通常指函数)
     位置变量:$1,$2..来表示,用于让脚步在脚本代码中调用通过命令行传递它的参数
     特殊变量:$?:上一个命令的执行结果
               $O:脚本文件路径本身
               $*:所有参数“ni hao”
               $@:所有参数“ni” “hao”
               $#:脚本参与的个数
本地变量
   变量赋值:name='value'
   可以使用引用value:
     (1)可以是直接字串:name=“root”
     (2)变量引用:name=“$USER”
     (3)命令引用:name=`COMMAND`,name=$(COMMAND)
   变量引用:${name},$name
     "":弱引用,其中的变量引用会被替换为变量值
     '':强引用,其中的变量引用不会被替换为变量值,而保持源字符串
   显示已定义的所有变量:set
   删除变量:unset name
环境变量
 变量声明、赋值:
   export name=VALUE
   declare -x name=VALUE
 变量引用:$name,${name}
 显示所有环境变量:
    export
    env
    printenv
 删除:unset name
 bash有许多内建的环境变量:PATH,SHELL,USER,UID,HISTSIZE,HOME,PWD,OLDPWD,HISTFILE,PS1
只读和位置变量
 只读变量:只能声时,但不能修改和删除
    readonly name
    declare -r name
  位置变量:在脚本代码中调用通过命令行传递给脚本的参数
     $1,$2,....:对应第1、第2等参数,shift [n]换位置
     $O:命令本身
     $*:传递给脚本的所有参数,全部参数合为一个字符串
     $@:传递给脚本的所有参数,每个参数为独立字符串
     $#:传递给脚本的参数的个数
         $@ $* 只在被双引号包起来的时候才会有差异
    示例:判断给出的文件的行数
       linecount="$(wc -l $1|cut -d"" -f1)"
       echo "$1 has $linecount lines"
算数运算
  bash中的算术运算:help let
     +,-,*,/,%,**
     实现算术运算
     (1)let var=算术表达式
     (2)var=$[算术表达式]
     (3)var=$((算术表达式))
     (4)var=$(expr arg1 arg2 arg3..)
      (5)declare -i var=数值
     (6)echo '算术表达式' |bc
 乘法符号有些场景中需要转义,如*
 bash有内建的随机数生成器:$RANDOM(1-32767)
   echo $[$RANDOM%50]:0-49之间随机数
赋值
   增强型赋值:
     +=,-=,*=,/=,%=
   let varOPERvalue
     例如:let count+=3
          自加3后字赋值
    自增,自减:
        let var+=1
        let var++
        let var-=1
        let var--
逻辑运算
  true ,false
     1,0
  与:
    1与1=1
    1与0=0
    0与1=0
    0与0=0
  或:
    1或1=1
    1或0=1
    0或1=1
    0或0=0
  非:!
    !1=0
    !0=1
  短路运算:
   短路与:
      第一个为0,结果必定为0;
      第一个为1,第二个必须要参与运算;
   短路或:
      第一个为1,结果必定为1;
      第一个为0,第二个必须要参与运算;
   异或:^
      异或的两个值,相同为假,不同为真
聚集命令
   有两种聚集命令的方法:
      复合式:date; who|wc -l
      命令会一个接一个地运行
      子shell:(date; who|wc -l)>>/tmp/trace
      所有的输出都被发送给单个STDOUT和STDERR
退出状态
   进程使用退出状态来报告成功或失败
     0 代表成功,1-255代表失败
     $? 变量保存最近的命令退出状态

   例如:
      $ping -c1 -W1 hostdown &> /dev/null
      $echo $?
退出状态码
    bash自定义退出状态码;
    exit [n]:自定义退出状态码;
    注意:脚本中一旦遇到exit命令,脚本会立即终止;终止退出状态取决于exit命令后面的数字
    注意:如果未给脚本指定退出状态码,整个脚本的退出状态取决于脚本执行的最后一条命令的状态码;
条件测试
    判断某需求是否满足,需要由测试机制来实现;
    专用的测试表达式需要由测试命令辅助完成测试过程;
    评估布尔声明,以便用在条件性执行中
       若真,则返回0
       若假,则返回1
    测试命令:
       test EXPRESSION
       [ EXPRESSION ]
       [[ EXPRESSION ]]
       注意:EXPRESSION前后必须有空白字符

  条件性的执行操作符
     根据退出状态而定,命令可以有条件地运行
        && 代表条件性的AND THEN
        || 代表条件性的OR ELSE
     例如:
       grep -q no_such_user /etc/passwd ||echo 'no such user'
 输出:no such user

ping -c1 -W2 station1 &> /dec/null && echo "station1 is up" || (echo 'station1 is unreachable';exit 1)

 test命令
   长格式的例子:
   test "$A" == "$B" && echo "string are equal"
   test "$A" -eq "$B" && echo "integers are equal"

   简写格式的例子:
   [ "$A" == "$B" ] && echo "strings are equal"
   [ "$A" -eq "$B" ] && echo "integers are equal"
bash的测试类型
 数值测试:
    -gt:是否大于;
    -ge:是否大于等于
    -eq:是否等于;
    -ne:是否不等于;
    -lt:是否小于
    -le:是否小于等于;

 字符串测试:
    ==:是否等于;
    >:ascii码是否大于ascii码
    <:是否小于
    !=:是否不等于
    =~:左侧字符串是否能被右侧的PATTERN所匹配
      注意:此表达式一般用于[[]]中;
     -z "STRING":字符串是否为空,空为真,不空为假
     -n "STRING":字符串是否不空,不空为真,空为假
  注意:用于字符串比较时的用到的操作数都应该使用引号
文件测试
   存在性测试
      -a FILE:同-e
      -e FILE:文件存在性测试,存在为真,否则为假;
   存在性及类别测试
      -b FILE:是否存在且为块设备文件;
      -c FILE:是否存在且为字符设备文件;
      -d FILE:是否存在且为目录文件;
      -f FILE:是否存在且为普通文件;
      -h FILE 或 -L FILE:存在且为符号链接文件;
      -p FILE:是否存在且为命名管道文件;
      -S FILE:是否存在且为套接字文件;
    文件权限测试:
      -r FILE:是否存在且可读
      -w FILE:是否存在且可写
      -x FILE:是否存在且可执行
    文件特殊权限测试:
      -g FILE:是否存在且拥有sgid权限;
      -u FILE:是否存在且拥有suid权限;
      -k FILE:是否存在且拥有sticky权限;
    文件大小测试:
      -s FILE:是否存在且非空;
    文件是否打开:
      -t fd:fd表示文件描述符是否已经打开且与某终端相关
      -N FILE:文件自动上一个被读取之后是否被修改过
      -O FILE:当前有效用户是否为文件属主
      -G FILE:当前有效用户是否为文件属组

    双目测试:
       FILE1 -ef FILE2:FILE1与FILE2是否指向同一个设备上的相同inode
       FILE1 -nt FILE2:FILE1是否新于FILE2
       FILE1 -ot FILE2:FILE1是否旧于FILE2


    组合测试条件
       第一种方式:
          COMMAND1 && COMMAND2 并且
          COMMAND1 || COMMAND2 或者
          !COMMAND  非
          如:[ -e FILE ] &&[ -r FILE ]

       第二种方式:
          EXPRESSION1 -a EXPRESSION2 并且
          EXPRESSION1 -o EXPRESSION2 或者
          !EXPRESSION
          必须使用测试命令进行;

[ -z "HOSTNAME" -o "$HOSTNAME"=="localhost.localdomain"]&&hostname www.magedu.com

[ -f /bin/cat -a -x /bin/cat ] && cat /etc/fstab

课后作业

1、编写脚本/root/bin/systeminfo.sh,显示当前主机系统信息,包括主机名, IPv4地址,操作系统版本,内核版本,CPU型号,内存大小,硬盘大小

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

不熟,重要2、编写脚本/root/bin/backup.sh,可实现每日将/etc/目录备份到/root/etcYYYY-mm-dd中

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

3、编写脚本/root/bin/disk.sh,显示当前硬盘分区中空间利用率最大的值

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

4、编写脚本/root/bin/links.sh,显示正连接本主机的每个远程主机的IPv4地址和连接数,并按连接数从大到小排序

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

5、写一个脚本/root/bin/sumid.sh,计算/etc/passwd文件中的第10个用户和第20用户的ID之和

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

6、写一个脚本/root/bin/sumspace.sh,传递两个文件路径作为参数给脚本,计算这两个文件中所有空白行之和

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

7、写一个脚本/root/bin/sumfile.sh,统计/etc, /var,/usr目录中共有多少个一级子目录和文件

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

8、写一个脚本/root/bin/argsnum.sh,接受一个文件路径作为参数;如果参数个数小于1,则提示用户“至少应该给一个参数”,并立即退出;如果参数个数不小于1,则显示第一个参数所指向的文件中的空白行数

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

9、写一个脚本/root/bin/hostping.sh,接受一个主机的IPv4地址做为参数,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

10、chmod -rw /tmp/file1,编写脚本/root/bin/per.sh,判断当前用户对/tmp/fiile1文件是否不可读且不可写

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

11、编写脚本/root/bin/nologin.sh和login.sh,实现禁止和充许普通用户登录系统。

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

12、写一个脚本/root/bin/hostping.sh,接受一个主机的IPv4地址做为参数,先判断是否合格IP,否,提示IP格式不合法并退出,是,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

13、计算1+2+3+…+100的值

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

14、计算从脚本第一参数A开始,到第二个参数B的所有数字的总和,判断B是否大于A,否提示错误并退出,是则计算之

月11日shell编程脚本及课后作业"

月11日shell编程脚本及课后作业"

原创文章,作者:15152188070,如若转载,请注明出处:http://www.178linux.com/34394

(0)
上一篇 2016-08-15 09:25
下一篇 2016-08-15 09:26

相关推荐

  • N25第九周作业

    1、写一个脚本,判断当前系统上所有用户的shell是否为可登录shell(即用户的shell不是/sbin/nologin);分别这两类用户的个数;通过字符串比较来实现; #!/bin/bash declare -a usersh nologin=0 login=0 usersh=($(cut -d’:’ -f7 /etc/passwd)) ##数组赋值时需…

    Linux干货 2017-03-04
  • 第四周学习总结

    写在最前 忙碌的一周又过去了,通过日夜兼程的追赶,也算基本上赶上了大部队的步伐。本周将继续对上一周的内容进行回顾加深,以达到对用户更加熟悉的管理,并讲讲三剑客中的老三。 知识详解 上一周我们说到了用户的管理,其中有像useradd、usermod、groupadd、passwd和userdel等非常重要的命令,每个用户都有自己特定的角色,在系统上完成不同的功…

    2017-12-24
  • lvm逻辑卷管理

    #LVM 逻辑卷管理 一、创建pv        创建pv可以在物理硬盘(裸盘上创建),MBR类型的分区(要更改分区类型为linux lvm: 8e )。GPT分区也要更改分区类型为8e00 Linux LVM 。    还可以在RAID上创建。注意要在没有数据的分区上…

    Linux干货 2016-09-02
  • mysql进阶之MySQL查询

    一、MySQL多表查询和子查询 别名:as        表别名        字段别名        查询结果亦可命名别名   联结查询:事先将两张或多张表join,根…

    2016-11-18
  • grep的使用和正则表达式

           grep作为Linux中的文本编辑的三剑客之一,它的功能很强大,并不是虚传,学会了grep在文本中找我们要找的的字符串总是能很轻易地找到,grep不仅仅就这一点功能,它在我们工作上也会对我们有很大的帮助。下面我来介绍一下grep的简单的功能。 grep :文本过滤( 模式:patter…

    Linux干货 2016-08-10
  • 2017中华数据库与运维大会强势回归!

         时隔一年,2017年中华数据库与运维大会将于06月03日在上海宝丰联大酒店强势回归,届时来自全国各行各业的IT从业人员将欢聚上海,探讨与交流数据库和运维的经验。       自2009年以来,超过4000位技术总监、技术负责人、架构师、项目经理、运维总监、运维经理、DBA经理、DBA、运维…

    2017-02-28

评论列表(2条)

  • 马哥教育
    马哥教育 2016-08-16 14:34

    层次分明,结构清晰图文并貌,态度端正,很用心,再接再励哦,